"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var NonEmptyArray_1 = require("fp-ts/lib/NonEmptyArray");
var ValidationFn = require("fp-ts/lib/Validation");
var Decoder_1 = require("./Decoder");
var ArrayD = /** @class */ (function (_super) {
    __extends(ArrayD, _super);
    function ArrayD(decoder) {
        var _this = _super.call(this) || this;
        _this.decoder = decoder;
        return _this;
    }
    ArrayD.prototype.run = function (valueArray) {
        var _this = this;
        if (Array.isArray(valueArray)) {
            return valueArray.reduce(function (validated, nextValue, index) {
                var validatedValue = _this.decoder.run(nextValue);
                return validatedValue.fold(function (errorsFromValue) {
                    var errors = errorsFromValue.map(function (errorText) { return errorText + " at index #" + index; });
                    return validated.fold(function (errorsFromValidated) { return ValidationFn.failure(errorsFromValidated.concat(errors)); }, function () { return ValidationFn.failure(errors); });
                }, function (successFromValue) { return validated.map(function (successes) { return successes.concat([successFromValue]); }); });
            }, ValidationFn.success([]));
        }
        var message = "Value must be an array, found \"" + typeof valueArray + "\" instead";
        return ValidationFn.failure(NonEmptyArray_1.nonEmptyArray.of(message));
    };
    return ArrayD;
}(Decoder_1.default));
exports.default = ArrayD;
