"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var NonEmptyArray_1 = require("fp-ts/lib/NonEmptyArray");
var ValidationFn = require("fp-ts/lib/Validation");
var Decoder_1 = require("./Decoder");
var Field = /** @class */ (function (_super) {
    __extends(Field, _super);
    function Field(field, decoder) {
        var _this = _super.call(this) || this;
        _this.decoder = decoder;
        _this.field = field;
        return _this;
    }
    Field.prototype.run = function (valueObject) {
        var _this = this;
        if (isObject(valueObject)) {
            if (this.field in valueObject) {
                return this.decoder.run(valueObject[this.field]).mapFailure(function (errors) { return errors.map(function (error) { return error + " at key \"" + _this.field + "\""; }); });
            }
            var noFieldMsg = "Object missing value at key \"" + this.field + "\"";
            return ValidationFn.failure(NonEmptyArray_1.nonEmptyArray.of(noFieldMsg));
        }
        var notObjectMsg = "Value must be a object, found \"" + typeof valueObject + "\" instead";
        return ValidationFn.failure(NonEmptyArray_1.nonEmptyArray.of(notObjectMsg));
    };
    return Field;
}(Decoder_1.default));
exports.default = Field;
function isObject(value) {
    return typeof value === 'object';
}
